#include <stdlib.h>
#include "nmd.h"

/*! Test setting and getting of scalar values */
int main(int argc,char **argv) {
  NMD_metadata nmd,nmd2; NMDErrorCode ierr; 
  NMDTruth flg; int i;
  PetscFunctionBegin;
  PetscInitialize(&argc,&argv,0,0);

  ierr = NMDCreateObject(&nmd); NMD_ERR_RETURN(ierr);
  ierr = NMDCreateObject(&nmd2); NMD_ERR_RETURN(ierr);

  i = 5;
  ierr = NMDSetValue(nmd,"cat1","cmp-i",NMDInt,&i); NMD_ERR_RETURN(ierr);
  i = 6;
  ierr = NMDSetValue(nmd,"cat1","cmp-ii",NMDInt,&i); NMD_ERR_RETURN(ierr);

  i = 27;
  ierr = NMDGetValue
    (nmd,"cat1","cmp-ii",NULL,(void*)&i,&flg); NMD_ERR_RETURN(ierr);
  if (!flg || i!=6) 
    NMD_ERR_REPORT("Trouble retrieving cmp-ii");
  ierr = NMDGetValue
    (nmd,"cat2","cmp-ii",NULL,(void*)&i,&flg); NMD_ERR_RETURN(ierr);
  if (flg)
    NMD_ERR_REPORT("This should not happen1");
  ierr = NMDGetValue
    (nmd2,"cat1","cmp-ii",NULL,(void*)&i,&flg); NMD_ERR_RETURN(ierr);
  if (flg)
    NMD_ERR_REPORT("This should not happen2");

  ierr = NMDDestroyObject(nmd); NMD_ERR_RETURN(ierr);
  ierr = NMDDestroyObject(nmd2); NMD_ERR_RETURN(ierr);

  PetscFinalize();
  PetscFunctionReturn(0);
}
